/*
Ŀ
  FILENAME : Actor.H                                      
  COMPILER : Turbo C++ Version 1.00                       
Ĵ
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     

*/

#if !defined(_ACTOR)
#define _ACTOR

// Definition of Walking of class ACTOR
#define WALK_L 0X01
#define WALK_Up 0X02
#define WALK_R 0X04
#define WALK_Dn 0X08
#define STAY 0X10


class ACTOR
{
	private :
		int DatumX, DatumY;

	protected :
		PathAPP *Map;
		size_t FloorSize;

		int CurX, CurY;
		BYTE CntStepWalk, FullStepWalk;		// Walking
		BYTE StepSize, FullStepSize;   	// A number of Pixel for Walking
		int RanRow, RanCol;
		BYTE Walking;
		DWORD DelayTimeMove, TimeLastChg;
		int MaxRow, MaxCol;
		int CurRow, CurCol;
		int RemoveRow, RemoveCol;
		BYTE DrawActor;  // = 1 when DrawActor was deleted.

		void RanPos( void );
		void RanDistPos( int row, int col, int dist );

	public :
		ACTOR( int row, int col, PathAPP *MP );
		ACTOR( PathAPP *MP );
		ACTOR( int FSWalk, PathAPP *MP );

		void CalCurPos( void );
		void GetCurPos( int *row, int *col );
		void GetCurPoint( int *X, int *Y );
		void GetRemovePos( int *row, int *col );
		void GetHoldPoint( int *HoldX, int *HoldY );

		void ChkActor( int row, int col );
};

class ACTOR2 : public ACTOR
{
	private :
		int Process, ProcessMask;
		BYTE ActorMove;

		int DeltaRadius;
		BYTE MajorType, MinorType;

		void RunProcess( void );
		void RanProcess( void );

		void GoodRandom( void );
		void BadRandom( void );


	public :
		ACTOR2( BYTE Type, int row, int col, PathAPP *MP );

		void Run( void );
		void SetNewPosition( void );
		inline int GetDeltaRadius( void )
		{  return DeltaRadius; }
		void SetNewPosition( int row, int col, int radius );
		inline BYTE GetMessage( void )
		{  return MinorType; }
};

class ACTOR1 : public ACTOR
{
	private :
		int Radius;
		int VsLen, VsLenHalf;
		int VsHoldX, VsHoldY;
		BYTE VsShowAll, VsWalking, VsActorMove;

		MapPtr ImaDummy, CirIma;
		MapPtr MindIma, MindShadow;

		int ChkFloor( int row, int col );
		void MakeCirIma( int HoldX, int HoldY );
		void AndCirIma( MapPtr Ima );
		void ViewActor( void );
		void Walk( void );

	public :
		ACTOR1( PathAPP *MP );
		~ACTOR1( void );

		void MakeALLIma( int radius );
		inline int GetRadius( void )
		{ 	return Radius;  }
		void SetRadius( int radius );
		inline void IncRadius( int IncRad )
		{   SetRadius( Radius + IncRad ); }
		inline void DecRadius( int DecRad )
		{	SetRadius( Radius - DecRad ); }

		void Vision( void );

		void Run( void );
};

#endif