#include <graphics.h>
#include <alloc.h>
#include <string.h>
#include <stdlib.h>
#include "graphic.h"
#include "standard.h"
#include "keyboard.h"
#include "path.h"
#include "actor.h"

#define DELAY_TIME_MOVE 2

ACTOR1::ACTOR1( PathAPP *MP ) :
ACTOR( MP )
{
	const unsigned char RandomRadius[] =
				   { 1, 2, 0, 1, 1, 1, 0, 2, 0, 1, 1, 3 };
	ImaDummy = (MapPtr) farmalloc( FloorSize );
	CirIma = (MapPtr) farmalloc( FloorSize );

	// Set Radius = Sum of Random 25 times
	int radius = 0;
	for( register int RanCnt = 0 ; RanCnt < 25 ; RanCnt++ )
		radius += RandomRadius[random(12)];

	DelayTimeMove = DELAY_TIME_MOVE;

	VsWalking = Radius = 0;
	MakeALLIma( radius );
	if( !ImaReadFile( &MindIma, "Mind.IMA" ) )
	{
		outtext("Mind.Ima error.\n");
		abort();
	}
	if( !ImaReadFile( &MindShadow, "MindSh.IMA" ) )
	{
		outtext("MindSh.Ima error.\n");
		abort();
	}
	SetButtonKeysMode();
}

void ACTOR1::Run( void )
{
	Walk();
	Vision();
}

void ACTOR1::MakeALLIma( int radius )
{
	if( Radius == radius )
		return;

	Radius = radius;
	VsLenHalf = radius + StepSize + 2;
	VsLen = 2 * VsLenHalf;
	VsShowAll = 1;
}

void ACTOR1::SetRadius( int radius )
{
	if( Radius == radius )
		return;
	if( radius < Radius )
	{
		int VsNewX = CurX - VsLenHalf;
		int VsNewY = CurY - VsLenHalf;
		int VsX2 = min( 479, VsNewX+VsLen );
		setfillstyle( SOLID_FILL, BLACK );
		bar( VsNewX, VsNewY, VsX2, VsNewY+VsLen );
	}
	MakeALLIma( radius );
	Vision();
}


void ACTOR1::Walk( void )
{
	WORD Walk = 0;

	if( GetKeyState(KEY_LEFT) )
		Walk |= WALK_L;
	if( GetKeyState(KEY_RIGHT) )
	{
		if( Walk )
			Walk |= 0X0100;
		Walk |= WALK_R;
	}
	if( GetKeyState(KEY_UP) )
	{
		if( Walk )
			Walk |= 0X0100;
		Walk |= WALK_Up;
	}
	if( GetKeyState(KEY_DOWN) )
	{
		if( Walk )
			Walk |= 0X0100;
		Walk |= WALK_Dn;
	}

	if( Walk & 0X0100 )
		Walk = 0;


	unsigned long int t = TIME;
	if( Walking )
	{
		switch( Walking ) {
		case WALK_L :
			if( Walk & WALK_R )
			{
				RemoveCol = CurCol;
				CurCol--;
				CntStepWalk = FullStepWalk - CntStepWalk;
				VsWalking = Walking = WALK_R;
				return;
			}
			if( t - TimeLastChg >= DelayTimeMove )
			{
				RemoveCol = CurCol - 1;
				TimeLastChg = t;
				CntStepWalk++;
				if( CntStepWalk >= FullStepWalk )
				{
					CntStepWalk = Walking = 0;
					CurCol--;
					RemoveCol++;
				}
				VsActorMove = 1;
			}
			return;

		case WALK_R :
			if( Walk & WALK_L )
			{
				RemoveCol = CurCol;
				CurCol++;
				CntStepWalk = FullStepWalk - CntStepWalk;
				VsWalking = Walking = WALK_L;
				return;
			}
			if( t - TimeLastChg >= DelayTimeMove )
			{
				RemoveCol = CurCol + 1;
				TimeLastChg = t;
				CntStepWalk++;
				if( CntStepWalk >= FullStepWalk )
				{
					CntStepWalk = Walking = 0;
					CurCol++;
					RemoveCol--;
				}
				VsActorMove = 1;
			}
			return;

		case WALK_Up :
			if( Walk & WALK_Dn )
			{
				RemoveRow = CurRow;
				CurRow--;
				CntStepWalk = FullStepWalk - CntStepWalk;
				VsWalking = Walking = WALK_Dn;
				return;
			}
			if( t - TimeLastChg >= DelayTimeMove )
			{
				RemoveRow = CurRow - 1;
				TimeLastChg = t;
				CntStepWalk++;
				if( CntStepWalk >= FullStepWalk )
				{
					CntStepWalk = Walking = 0;
					CurRow--;
					RemoveRow++;
				}
				VsActorMove = 1;
			}
			return;

		case WALK_Dn :
			if( Walk & WALK_Up )
			{
				RemoveRow = CurRow;
				CurRow++;
				CntStepWalk = FullStepWalk - CntStepWalk;
				VsWalking = Walking = WALK_Up;
				return;
			}
			if( t - TimeLastChg >= DelayTimeMove )
			{
				RemoveRow = CurRow + 1;
				TimeLastChg = t;
				CntStepWalk++;
				if( CntStepWalk >= FullStepWalk )
				{
					CntStepWalk = Walking = 0;
					CurRow++;
					RemoveRow--;
				}
				VsActorMove = 1;
			}
			return;
		}
	}
	else
	{
		int col = CurCol;
		int row = CurRow;
		switch( Walk ) {
		case WALK_L :
			col--;
			if( Map->HaveFloor(row,col) )
				Walking = Walk;
			break;
		case WALK_R :
			col++;
			if( Map->HaveFloor(row,col) )
				Walking = Walk;
			break;
		case WALK_Up :
			row--;
			if( Map->HaveFloor(row,col) )
				Walking = Walk;
			break;
		case WALK_Dn :
			row++;
			if( Map->HaveFloor(row,col) )
				Walking = Walk;
			break;
		}
		VsWalking = Walking;
		if( Walking )
		{
			if( t - TimeLastChg > DelayTimeMove )
				TimeLastChg = t;
			RemoveRow = CurRow;
			RemoveCol = CurCol;
		}
	}
}


void ACTOR1::MakeCirIma( int HoldX, int HoldY )
{
	memset( CirIma, 0, FloorSize );
	int far *IntPtr = (int far *) CirIma;
	*IntPtr++ = 11;
	*IntPtr = 11;
	ImaFillCircle( CirIma, CurX-HoldX, CurY-HoldY, Radius, WHITE );
}

void ACTOR1::AndCirIma( MapPtr Ima )
{
	MapPtr Des = Ima;
	Des += 4;
	MapPtr Src = CirIma;
	Src += 4;
	int MaxCntLoop = FloorSize - 6;
	for( register int i = 0 ; i < MaxCntLoop ; i++, Des++, Src++ )
		*Des &= *Src;
}

void ACTOR1::Vision( void )
{
	ACTOR::CalCurPos();

	int VsNewX = CurX - VsLenHalf;
	int VsNewY = CurY - VsLenHalf;

	int FloorLeft = VsNewX / 12;
	int FloorRight = ( VsNewX + VsLen ) / 12;
	int FloorTop = VsNewY / 12;
	int FloorBottom = ( VsNewY + VsLen ) /12;

	int FLMark = max( 0, FloorLeft );
	int FRMark = min( 39, FloorRight );
	int FTMark = max( 0, FloorTop );
	int FBMark = min( 39, FloorBottom );

	int X, Y, FRow, FCol;
	int index;

	VsHoldX = VsNewX;
	VsHoldY = VsNewY;
	setfillstyle( SOLID_FILL, BLACK );

	if( VsShowAll )
	{
		VsWalking = WALK_L;
		VsActorMove = 1;
	}

	unsigned char DrawFullFloor, SomePartDo;
	if( VsActorMove )
	{
		switch( VsWalking ) {
		case WALK_L :
			for( FRow = FTMark  ; FRow <= FBMark ; FRow++ )
			{
				DrawFullFloor = SomePartDo = 0;
				for( FCol = FLMark ; FCol <= FRMark ; FCol++ )
				{
					switch( ChkFloor(FRow,FCol) ) {
					case 0 :    // No part of floor is in Radius area
						if( SomePartDo )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							bar( X, Y, X+11, Y+11 );
							FCol = FRMark;
						}
						break;

					case 1 :   	// Have some part of floor is in Radius area
						if( Map->DrawFloor( FRow, FCol, ImaDummy ) )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							MakeCirIma( X, Y );
							AndCirIma( ImaDummy );
							putimage( X, Y, ImaDummy, COPY_PUT );
						}
						SomePartDo = 1;
						break;

					case 2 : 	// Full part of floor is in Radius area
						if( !DrawFullFloor )
							Map->DrawFloor( FRow, FCol );
						else
							break;
						if( !VsShowAll )
							DrawFullFloor = 1;
						break;
					}
				}
			}
			break;  		// End case of WALK_L

		case WALK_R :
			for( FRow = FTMark  ; FRow <= FBMark ; FRow++ )
			{
				DrawFullFloor = SomePartDo = 0;
				for( FCol = FRMark ; FCol >= FLMark ; FCol-- )
				{
					switch( ChkFloor(FRow,FCol) ) {
					case 0 :    // No part of floor is in Radius area
						if( SomePartDo )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							bar( X, Y, X+11, Y+11 );
							FCol = FLMark;
						}
						break;

					case 1 :   	// Have some part of floor is in Radius area
						if( Map->DrawFloor( FRow, FCol, ImaDummy ) )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							MakeCirIma( X, Y );
							AndCirIma( ImaDummy );
							putimage( X, Y, ImaDummy, COPY_PUT );
						}
						SomePartDo = 1;
						break;

					case 2 : 	// Full part of floor is in Radius area
						if( !DrawFullFloor )
							Map->DrawFloor( FRow, FCol );
						else
							break;
						if( !VsShowAll )
							DrawFullFloor = 1;
						break;
					}
				}
			}
			break;  		// End case of WALK_R

		case WALK_Up :
			for( FCol = FLMark  ; FCol <= FRMark ; FCol++ )
			{
				DrawFullFloor = SomePartDo = 0;
				for( FRow = FTMark ; FRow <= FBMark ; FRow++ )
				{
					switch( ChkFloor(FRow,FCol) ) {
					case 0 :    // No part of floor is in Radius area
						if( SomePartDo )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							bar( X, Y, X+11, Y+11 );
							FRow = FBMark;
						}
						break;

					case 1 :   	// Have some part of floor is in Radius area
						if( Map->DrawFloor( FRow, FCol, ImaDummy ) )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							MakeCirIma( X, Y );
							AndCirIma( ImaDummy );
							putimage( X, Y, ImaDummy, COPY_PUT );
						}
						SomePartDo = 1;
						break;

					case 2 : 	// Full part of floor is in Radius area
						if( !DrawFullFloor )
							Map->DrawFloor( FRow, FCol );
						else
							break;
						if( !VsShowAll )
							DrawFullFloor = 1;
						break;
					}
				}
			}
			break;  		// End case of WALK_Up

		case WALK_Dn :
			for( FCol = FLMark  ; FCol <= FRMark ; FCol++ )
			{
				DrawFullFloor = SomePartDo = 0;
				for( FRow = FBMark ; FRow >= FTMark ; FRow-- )
				{
					switch( ChkFloor(FRow,FCol) ) {
					case 0 :    // No part of floor is in Radius area
						if( SomePartDo )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							bar( X, Y, X+11, Y+11 );
							FRow = FTMark;
						}
						break;

					case 1 :   	// Have some part of floor is in Radius area
						if( Map->DrawFloor( FRow, FCol, ImaDummy ) )
						{
							Map->CalHoldPoint( FRow, FCol, &X, &Y );
							MakeCirIma( X, Y );
							AndCirIma( ImaDummy );
							putimage( X, Y, ImaDummy, COPY_PUT );
						}
						SomePartDo = 1;
						break;

					case 2 : 	// Full part of floor is in Radius area
						if( !DrawFullFloor )
							Map->DrawFloor( FRow, FCol );
						else
							break;
						if( !VsShowAll )
							DrawFullFloor = 1;
						break;
					}
				}
			}
			break;  		// End case of WALK_Dn
		}

		if( ChkFloor( CurRow, CurCol ) == 2 )
		{
			Map->DrawFloor( CurRow, CurCol );
			if( ChkFloor( RemoveRow, RemoveCol ) == 2 )
				Map->DrawFloor( RemoveRow, RemoveCol );
		}
		DrawActor = 1;
		// VsActor is set because of the actor image was deleted
	}      			// End if VsActorMove == 1

	if( DrawActor )
	{
		ViewActor();				// Display view of Actor1 (player)
		DrawActor = !DrawActor;
	}

	VsWalking = Walking;
	VsActorMove = VsShowAll = 0;
}

void ACTOR1::ViewActor( void )
{
	putimage( CurX-6, CurY-6, MindShadow, AND_PUT );
	putimage( CurX-6, CurY-6, MindIma, OR_PUT );

	if( !CntStepWalk )
	{
		RemoveRow = CurRow;
		RemoveCol = CurCol;
	}
}

// return 0 	No part of floor isn't in Radius area
// return 1		Have some part of floor is in area Radius area
// return 2		Full part of floor is in area Radius area
int ACTOR1::ChkFloor( int row, int col )
{
	// The ChkFloor for check that is the given FRow, FCol in Radius area?
	// 0  	No part of floor isn't in Radius area
	// 1-3 	Have some part of floor is in area Radius area
	// 4 	Full part of floor is in area Radius area
	BYTE CntPointIn = 0;

	long int R2 = (long int) Radius;
	R2 *= R2;
	Map->CalXYBorder( row, col );

	BYTE XIndex, YIndex;
	long int XMark, YMark;

	for( YIndex = 0 ; YIndex < 2 ; YIndex++ )
	{
		YMark = (long) ( Map->YBorder[YIndex] - CurY );
		YMark *= YMark;
		for( XIndex = 0 ; XIndex < 2 ; XIndex++ )
		{
			XMark = (long) ( Map->XBorder[XIndex] - CurX );
			XMark *= XMark;
			if( XMark + YMark <= R2 )  // True ==> point is in Radius area
			{
				if( !CntPointIn && (YIndex || XIndex) )
					return 1; 	// Have some part of floor in Radius area
				CntPointIn++;
			}
			else
				if( CntPointIn )
					return 1;
		}
	}
	if( CntPointIn )
		return 2;
	return 0;
}

ACTOR1::~ACTOR1( void )
{
	if( ImaDummy )
		farfree( ImaDummy );
	if( CirIma )
		farfree( CirIma );
	if( MindIma )
		farfree( MindIma );
	if( MindShadow )
		farfree( MindShadow );
	SetNormalKeysMode();
}
