/*==========================================================
// Filename : Border.CPP
// Written by : MENGWRR
// Complier : Turbo C
==========================================================*/

#include <graphics.h>
#include "border.h"

typedef unsigned char BYTE;
typedef unsigned int WORD;
int FLOOR_COLOR = LIGHTGRAY;
int BORDER_COLOR = BLACK;

void BDDraw( BORDER *bor , int UpDown, int Depth )
{
	BDFillIn( bor, FLOOR_COLOR, BORDER_COLOR );
	BDLine( bor, UpDown, Depth );
}

void BDLine( BORDER *bor , int UpDown, int Depth )
{
	BYTE Color[2];
	int d;

	if( UpDown )
	{
		Color[0] = LIGHT_COLOR;
		Color[1] = DARK_COLOR;
	}
	else
	{
		Color[0] = DARK_COLOR;
		Color[1] = LIGHT_COLOR;
	}

	setcolor( Color[0] );
	for( d = Depth ; d ; d-- )
	{
		line( bor->Left+d, bor->Top+d, bor->Right-d, bor->Top+d );
		line( bor->Left+d, bor->Top+d, bor->Left+d, bor->Bottom-d );
	}

	setcolor( Color[1] );
	for( d = Depth ; d ; d-- )
	{
		line( bor->Right-d, bor->Bottom-d, bor->Right-d, bor->Top+d );
		line( bor->Right-d, bor->Bottom-d, bor->Left+d, bor->Bottom-d );
	}

	setcolor( BORDER_COLOR );
	rectangle( bor->Left, bor->Top, bor->Right, bor->Bottom );
}

void BDFillIn( BORDER *bor, int FloorColor, int BounColor )
{
	setfillstyle( SOLID_FILL, FloorColor );
	setcolor( BounColor );
	bar( bor->Left, bor->Top, bor->Right, bor->Bottom );
	rectangle( bor->Left, bor->Top, bor->Right, bor->Bottom );
}


void BDLayOut( BORDER *bor, BYTE Color, BYTE Thickness )
{
	setcolor( Color );
	for( ; Thickness ; Thickness-- )
	{
		rectangle( bor->Left+Thickness, bor->Top+Thickness,
				   bor->Right-Thickness, bor->Bottom-Thickness );
	}
	setcolor( BORDER_COLOR );
	rectangle( bor->Left, bor->Top, bor->Right, bor->Bottom );
}

void BDPaint( BORDER *bor, BYTE FloorColor )
{
	setfillstyle( SOLID_FILL, FloorColor );
	setcolor( BORDER_COLOR );
	bar( bor->Left, bor->Top, bor->Right, bor->Bottom );
	rectangle( bor->Left, bor->Top, bor->Right, bor->Bottom );
}

void BDDrawBox( BORDER *bor, int SideUD, int Depth )
{
	BYTE Color[2];
	int d;
	int PointMark;

	if( SideUD & BoxUp )
	{
		Color[0] = LIGHT_COLOR;
		Color[1] = DARK_COLOR;
	}
	else
	{
		Color[0] = DARK_COLOR;
		Color[1] = LIGHT_COLOR;
	}

	setfillstyle( SOLID_FILL, FLOOR_COLOR );
	bar( bor->Left, bor->Top, bor->Right, bor->Bottom );

	/*========== Left Side ===========*/
	if( SideUD & LeftSide )
	{
		if( SideUD & TopSide )
			PointMark = bor->Top + 1;
		else
			PointMark = bor->Top;

		setcolor( Color[0] );
		if( SideUD & BottomSide )
			for( d = Depth ; d ; d-- )
				line( bor->Left+d, PointMark, bor->Left+d, bor->Bottom-d );
		else
			for( d = Depth ; d ; d-- )
				line( bor->Left+d, PointMark, bor->Left+d, bor->Bottom );

		setcolor( BORDER_COLOR );
		line( bor->Left, bor->Top, bor->Left, bor->Bottom );
	}

	/*========== Top Side ===========*/
	if( SideUD & TopSide )
	{
		if( SideUD & LeftSide )
			PointMark = bor->Left + 1;
		else
			PointMark = bor->Left;

		setcolor( Color[0] );
		if( SideUD & RightSide )
			for( d = Depth ; d ; d-- )
				line( PointMark, bor->Top+d, bor->Right-d, bor->Top+d );
		else
			for( d = Depth ; d ; d-- )
				line( PointMark, bor->Top+d, bor->Right, bor->Top+d );

		setcolor( BORDER_COLOR );
		line( bor->Left, bor->Top, bor->Right, bor->Top );
	}

	/*========== Right Side ===========*/
	if( SideUD & RightSide )
	{
		if( SideUD & BottomSide )
			PointMark = bor->Bottom - 1;
		else
			PointMark = bor->Bottom;

		setcolor( Color[1] );
		if( SideUD & TopSide )
			for( d = Depth ; d ; d-- )
				line( bor->Right-d, bor->Top+d, bor->Right-d, PointMark );
		else
			for( d = Depth ; d ; d-- )
				line( bor->Right-d, bor->Top, bor->Right-d, PointMark );

		setcolor( BORDER_COLOR );
		line( bor->Right, bor->Top, bor->Right, bor->Bottom );
	}

	/*========== Bottom Side ===========*/
	if( SideUD & BottomSide )
	{
		if( SideUD & RightSide )
			PointMark = bor->Right - 1;
		else
			PointMark = bor->Right;

		setcolor( Color[1] );
		if( SideUD & LeftSide )
			for( d = Depth ; d ; d-- )
				line( bor->Left+d, bor->Bottom-d, PointMark, bor->Bottom-d );
		else
			for( d = Depth ; d ; d-- )
				line( bor->Left, bor->Bottom-d, PointMark, bor->Bottom-d );

		setcolor( BORDER_COLOR );
		line( bor->Left, bor->Bottom, bor->Right, bor->Bottom );
	}
}   /*============= End of DrawBox =======================*/
