/*
ͻ
  FILENAME : Control.CPP                                  
  COMPILER : Turbo C++ Version 1.00                       
  INCLUDE  : Control.H, Graphic.H, Standard.H, Getkey.H   
                                                          
͹
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     
ͼ
*/

#include <graphics.h>
#include <alloc.h>
#include "graphic.h"
#include "standard.h"
#include "getkey.h"
#include "control.h"

DWORD BlinkTime = 10;


ImaCtrl::ImaCtrl( int SX, int SY, int row, int col, int resX, int resY,
				  MapPtr Ima )
{
	int far *Size = (int far *)Ima;
	StartX = SX;
	StartY = SY;
	Row = row;
	Col = col;
	ResX = resX;
	ResY = resY;
	ImaShow = CurRow = CurCol = ImaActive = CtrlRun = 0;
	Image = Ima;
	SizeX = *Size++;
	SizeY = *Size;
	ImaPick = (MapPtr) farmalloc( imagesize(0,0,SizeX,SizeY) );
}

void ImaCtrl::SwitchOn( void )
{
	if( CtrlRun )
		return;
	CtrlRun = !CtrlRun; // CtrlRun = 1
	GetImage();
	Active();
	TimeLastCur = TIME;
}

void ImaCtrl::SwitchOff( void )
{
	if( !CtrlRun )
		return;
	CtrlRun = !CtrlRun; // == 0
	Restore();
}

WORD ImaCtrl::Run( void )
{
	WORD key;
	WORD ChkKey = 0;

	if( !CtrlRun )
		return 0;

	key = getkeyOnly();
	switch( key ) {
		case LArrow : ChkKey = 0X01; goto commonL;
		case 0X73E0 : ChkKey = 0X11; goto commonL; 	// Ctrl Left
		case 0X9B00 : ChkKey = 0X21; 				// Alt Left
		commonL :
			CurCol--;
			if( CurCol < 0 )
				CurCol = Col - 1;
			ChkKey = 1;
			break;
		case RArrow : ChkKey = 0X02; goto commonR;
		case 0X74E0 : ChkKey = 0X12; goto commonR; 	// Ctrl Right
		case 0X9D00 : ChkKey = 0X22; 				// Alt Right
		commonR :
			CurCol++;
			if( CurCol >= Col )
				CurCol = 0;
			ChkKey = 1;
			break;
		case UpArrow : ChkKey = 0X04; goto commonUp;
		case 0X8DE0 : ChkKey = 0X13; goto commonUp;	// Ctrl Up
		case 0X9800 : ChkKey = 0X23; 				// Alt Up
		commonUp :
			CurRow--;
			if( CurRow < 0 )
				CurRow = Row - 1;
			ChkKey = 1;
			break;
		case DnArrow : ChkKey = 0X04; goto commonDn;
		case 0X91E0 : ChkKey = 0X14; goto commonDn;	// Ctrl Dn
		case 0XA000 : ChkKey = 0X24; 				// Alt Dn
		commonDn :
			CurRow++;
			if( CurRow >= Row )
				CurRow = 0;
			ChkKey = 1;
			break;
	}

	if( ChkKey )
	{
		clrkeyOne();
		NewRC( CurRow, CurCol );
		return ChkKey;
	}
	TimeCtrl();
	return 0;
}

void ImaCtrl::GetRC( int *row, int *col )
{
	*row = CurRow;
	*col = CurCol;
}

void ImaCtrl::GetXY( int *x, int *y )
{
	CalBorder();
	*x = Left + SizeX/2;
	*y = Top + SizeY/2;
}

void ImaCtrl::Restore( void )
{
	if( ImaActive )
	{
		putimage( Left, Top, ImaPick, COPY_PUT );
		ImaActive = !ImaActive;         // ImaActive == 0
	}
}

void ImaCtrl::Active( void )
{
	ImaActive = 1;
	PutImage( Left, Top, Image );
}

void ImaCtrl::NewRC( int row, int col )
{
	Restore();    			// Restore image of the old picture
	CurRow = row;
	CurCol = col;
	GetImage();
	Active();
	TimeLastCur = TIME;
}

void ImaCtrl::GetImage( void )
{
	CalBorder();
	getimage( Left, Top, Right, Bottom, ImaPick );
}

void ImaCtrl::CalBorder( void )
{
	Left = StartX + CurCol*ResX;
	Right = Left + SizeX;
	Top = StartY + CurRow*ResY;
	Bottom = Top + SizeY;
}

void ImaCtrl::TimeCtrl( void )
{
	DWORD t = TIME;
	if( t - TimeLastCur >= BlinkTime )
	{
		TimeLastCur = t;
		if( ImaActive )
			Restore();
		else
			Active();
	}
}

ImaCtrl::~ImaCtrl( void )
{
	SwitchOff();
	if( Image )
		farfree( Image );
	if( ImaPick )
		farfree( ImaPick );
}