#if !defined(_GRAPHIC_)
#define _GRAPHIC_

typedef unsigned char far *MapPtr;
typedef struct {
	int MaxX, MaxY;
	int BytePerPlane, BytePerLine;
	unsigned int Offset;
	unsigned char Mask;
	} ImaInfo;

void StartGraphics( void );
// int gprintf( int x, int y, char *fmt, ... );
int Gprintf( int x, int y, char *fmt, ... );
int TextWidth( char *fmt, ... );
int TextHeight( char *fmt, ... );

void SetPlane( int plane );
void SetBltBit( int bltbit );

void ImageInfo( ImaInfo *Info, void far *bitmap );
void ImageInfo( ImaInfo *Info, void far *bitmap, int x, int y );

void PutPicture( int x, int y, void far *bitmap, int bitblt );
void PutImage( int x, int y, void far *Image, int option );
void ImaBltBit( void far *back, int x, int y, void far *fore, int option );

void ImaLine( MapPtr Image, int x1, int y1, int x2, int y2, int color );
void ImaBar( MapPtr Image, int x1, int y1, int x2, int y2, int color );
void ImaFillCircle( MapPtr Image, int x, int y, int radius, int color );

void ImaMoveLeft( MapPtr Image, int DeltaX );
void ImaMoveRight( MapPtr Image, int DeltaX );
void ImaMoveUp( MapPtr Image, int DeltaY );
void ImaMoveDn( MapPtr Image, int DeltaY );

int ImaWriteFile( MapPtr Image, char *filename );
int ImaReadFile( MapPtr *Image, char *filename );

#endif