#include <stdio.h>
#include <graphics.h>
#include <alloc.h>
#include "graphic.h"
#include "image.h"

ImageAPP::ImageAPP( int PX, int PY )
{
	size_t size = imagesize( 1, 1, PX, PY );
	BitIma = Image = (MapPtr) farmalloc( size );
	for( int i = 0 ; i < size ; i++ )
		*BitIma = 0;
	PixelX = PX - 1;
	PixelY = PY - 1;
	BitIma = Image;
	*(int far *)BitIma = PX - 1;
	((int far *)BitIma)++;
	*(int far *)BitIma = PY - 1;
	ImageAPP( Image );
}


ImageAPP::ImageAPP( void far *Ima )
{
	Image = (MapPtr) Ima;
	PixelX = (*(int far *)Ima);
	((int far *)Ima)++;
	PixelY = (*(int far *)Ima);
	((int far *)Ima)++;
	BitIma = (MapPtr) Ima;
	Delta = PixelX/8 + 1;
	Delta4 = 4*Delta;
}

void ImageAPP::Plot( int px, int py, int color )
{
	SetBitPlane( px, py );
	unsigned char Mask = 0X08;
	for( int i = 0 ; i < 4 ; i++, Mask >>= 1 )
	{
		if( Mask & color )
			*BitPlane[i] |= BitMask;
		else
			*BitPlane[i] &= BitMask ^ 0XFF;
	}
}

int ImageAPP::GetPixel( int px, int py )
{
	int RetColor = 0;
	SetBitPlane( px, py );
	unsigned char Mask = 0X08;
	for( int i = 0 ; i < 4 ; i++, Mask >>= 1 )
	{
		if( *BitPlane[i] & BitMask )
			RetColor |= Mask;
	}
	return RetColor;
}


void ImageAPP::SetBitPlane( int px, int py )
{
	BitMask = 0X80;
	BitMask >>= px%8;
	BitPlane[0] = BitIma + py*Delta4 + px/8;
	BitPlane[1] = BitPlane[0] + Delta;
	BitPlane[2] = BitPlane[1] + Delta;
	BitPlane[3] = BitPlane[2] + Delta;
}

void ImageAPP::Putimage( int x, int y, int option )
{
	putimage( x, y, Image, option );
}

void ImageAPP::Putimage( int x, int y )
{
	PutImage( x, y, Image );
}
