#include <graphics.h>
#include <string.h>
#include <alloc.h>
#include <stdlib.h>
#include "graphic.h"
#include "message.h"

char *MessageText[] = {
		"$3(Venerable Father)",     // Message 0 - 13
		"$3(Venerable Brother)",
		"$3(Monks)",
		"$3(Novices)",
		"$3(Mom & Dad)",
		"$3(Teachers)",
		"$3(Grandparents)",
		"$3(Uncles)",
		"$3(Aunts)",
		"$3(Brothers)",
		"$3(Sisters)",
		"$3(Elders)",
		"$3(Friends)",
		"$3(Kids)",

		"$4(Sensual Desire)",  	// Message 14 - 18
		"$4(Illwill)",
		"$4(Sloth & Torpor)",
		"$4(Distraction & Remorse)",
		"$4(Doubt)",

		"Come with the darkness.",         	// Message 19 - 20
		"Come with the light.",

		"Iife is nearly end.",        		// Message 21 - 22
		"Iife is nearly end.",

		"$2Look for KALYANAMITRA",          // Message 23 - 27
		"$2Look for KALYANAMITRA",
		"$2Look for KALYANAMITRA",
		"$2Centre your mind$4!!!!",
		"$2Centre your mind$4!!!!",

		"$4Sammaa Arahamg",  // Message 28 - 29
		"$4Be conscious of\nyour good deeds."
		};

char *GoodMeanText[] = {
	"$2Kalyanamitra\n"
//	 000000000000000000
	"$0Your guide or\n"
	"advisor gives you\n"
	"security and\n"
	"loving kindness,\n"
	"is a good friend\n"
	"and is an exemplar\n"
	"of good morality"
	};

char *CommonBadMeanText[] = {
	"$2The Five Hindrances\n"
//	 000000000000000000
	"$0Obstacles to\n"
	"mental progress\n"
	"towards virtue-\n"
	"unskilfulness that\n"
	"clouds the mind\n"
	"and gets in the\n"
	"way of wisdom"
	};

char *BadMeanText[] = {
	"$4Sensual Desire\n"
	"$0Craving for sensual pleasure",

	"$4Illwill\n"
	"$0Aggressive or\n"
	"vengeful thought",

	"$4Sloth and Torpor\n"
	"$0Sleepiness or \n"
	"laziness",

	"$4Distraction and\n"
	"Remorse\n"
	"$0Absent mindedress,\n"
	"day dreaming, and\n"
	"anxiety",

	"$4Doubt\n"
	"$0Hesitation and\n"
	"Uncertainty"
	};


#define TIME_MESSAGE_SHOW 50
#define C_TEXT BLUE
#define C_BORDER CYAN
#define C_FLOOR WHITE

static BORDER GoodMsgBor = { 480, 270, 639, 450 };
static BORDER BadMsgBor1 = { 480, 250, 639, 370 };
static BORDER BadMsgBor2 = { 480, 385, 639, 479 };

MESSAGE::MESSAGE( int BX, int BY, int radius, int Code )
{
	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );

	MsgCode = Code;
	if( Code < 14 )
		strcpy( MsgText, "$3Meet kalyanamitra\n" );
	else if( Code < 19 )
		strcpy( MsgText, "$4Hindrance\n" );
	else
		MsgText[0] = '\0';
	strcat( MsgText, MessageText[Code] );

	MsgWidth = TextWidth( MsgText );
	MsgHeight = TextHeight( MsgText );

	BaseX = BX;
	BaseY = BY;

	CalMsgBorder( radius );
	SaveScr = (char far *) farmalloc(
			  imagesize( 480, Border.Top,
						 640, Border.Bottom ) );
	SaveChk = 0;

//	TextOffsetX = 10;
//	TextOffsetY = 10;

	DrawMsgBox();

	int index, YRun;

	if( Code < 19 )
	{
		BORDER_COLOR = LIGHTBLUE;
		setfillstyle( SOLID_FILL, RED );
		bar( 480, 250, 639, 479 );
	}

	if( Code < NUM_GOOD_ACTOR )
	{
		YRun = GoodMsgBor.Top + 10;
		BDFillIn( &GoodMsgBor, WHITE, LIGHTBLUE );
		BDLayOut( &GoodMsgBor, LIGHTBLUE, 3 );
		Gprintf( 490, YRun, GoodMeanText[0] );
	}
	else if( Code < 19 )
	{
		BDFillIn( &BadMsgBor1, WHITE, LIGHTBLUE );
		BDLayOut( &BadMsgBor1, LIGHTBLUE, 3 );
		BDFillIn( &BadMsgBor2, WHITE, LIGHTBLUE );
		BDLayOut( &BadMsgBor2, LIGHTBLUE, 3 );

		YRun = BadMsgBor1.Top + 10;
		Gprintf( 490, YRun, CommonBadMeanText[0] );

		int MarkText = Code-14;
		YRun = BadMsgBor2.Top + 10;
		Gprintf( 490, YRun, BadMeanText[MarkText] );
	}

	StartTime = TIME;
}

int MESSAGE::Run( int BX, int BY )
{
	if( TIME - StartTime >= TIME_MESSAGE_SHOW )
		return 0;
	BaseMove( BX, BY );
	return 1;
}

void MESSAGE::CalMsgBorder( int radius )
{
	radius *= 6;
	radius /= 7;
	Border.Left = BaseX;
	Border.Top = BaseY;
	if( BaseX < 240 )
		Border.Left += radius;
	else
		Border.Left -= radius + MsgWidth + 20;
	if( BaseY < 240 )
		Border.Top += radius;
	else
		Border.Top -= radius + MsgHeight + 20;
	Border.Right = Border.Left + MsgWidth + 20;
	Border.Bottom = Border.Top + MsgHeight + 20;
}

void MESSAGE::DrawMsgBox( void )
{
	if( Border.Right >= 480 )
	{
		SaveChk = 1;
		SaveX = 480;
		SaveY = Border.Top;
		getimage( 480, Border.Top,
				  Border.Right, Border.Bottom, SaveScr );
	}

	BORDER_COLOR = BLUE;
	setfillstyle( SOLID_FILL, C_FLOOR );
	bar( Border.Left, Border.Top, Border.Right, Border.Bottom );
	BDLayOut( &Border, C_BORDER, 3 );

	settextstyle( DEFAULT_FONT, HORIZ_DIR, 1 );
	settextjustify( LEFT_TEXT, TOP_TEXT );
	setcolor( C_TEXT );
	Gprintf( Border.Left+10, Border.Top+10, MsgText );
}

void MESSAGE::ClearMsgBox( void )
{
	setfillstyle( SOLID_FILL, BLACK );
	int right = min( Border.Right, 479 );
	bar( Border.Left, Border.Top, right, Border.Bottom );
	if( SaveChk )
	{
		putimage( SaveX, SaveY, SaveScr, COPY_PUT );
		SaveChk = 0;
	}
}

void MESSAGE::BaseMove( int BX, int BY )
{
	if( BX == BaseX && BY == BaseY )
		return;
	int DeltaX = BX - BaseX;
	int DeltaY = BY - BaseY;
	BaseX = BX;
	BaseY = BY;

	ClearMsgBox();

	Border.Left += DeltaX;
	Border.Right += DeltaX;
	Border.Top += DeltaY;
	Border.Bottom += DeltaY;
	DrawMsgBox();
}

MESSAGE::~MESSAGE( void )
{
	ClearMsgBox();
	if( SaveScr )
		farfree( SaveScr );
}
