/*
Ŀ
  FILENAME : Path.H                                       
  COMPILER : Turbo C++ Version 1.00                       
Ĵ
  Present by MR.Watcharop   Riangrungrote (WRR)           
             Mechanical   Engineering                     
             Chulalongkorn University                     

*/

#if !defined(_PATH_H_)
#define _PATH_H_
#include "standard.h"

#define MAX_FINAL 10

class PathAPP
{
	private :
		int HaveFinal( int row, int col );
		void LineWall( int row, int col );


	protected :
		int StartX, StartY, MaxRow, MaxCol;
		BYTE WallColor;

		BYTE MaxFinal;
		struct {
			int Row, Col;
			} Final[MAX_FINAL];
		int FinalSelected;

		MapPtr FloorIma;
		MapPtr Map;
		MapPtr FinalIma;
		size_t SizeFloor, SizeMap;

		BYTE Complete;

		WORD PosByte;
		BYTE PosBit;

		void CalPosition( int row, int col );
		BYTE ReadFinalIma( void );  // Call only in constructor

		BYTE PixelPerBlock;
 		BYTE Designer[100];

	public :
		// The below variables is changed in CalXYBorder MODULE
		int XBorder[2], YBorder[2];

		PathAPP( int row, int col, BYTE PPB, MapPtr floor );
        PathAPP( char *filename );
		~PathAPP( void );
		inline BYTE GetComplete( void )
		{  return Complete; }

		virtual int WriteFile( char *filename );
		virtual int ReadFile( char *filename );

		WORD HaveFloor( int row, int col );
		int GetDirecMap( int row, int col );
		int ToggleFinal( int row, int col );
		void GetFinal( int *row, int *col )
		{
			*row = Final[FinalSelected].Row;
			*col = Final[FinalSelected].Col;
		}

		BYTE SetFloorIma( MapPtr floor );
		void DrawFloor( int row, int col );
		int DrawFloor( int row, int col, MapPtr Ima );
		void UpdateFloor( int row, int col );
		virtual void DrawMap( void );

		void RandomFinal( void );

		BYTE Add( int row, int col );
		BYTE Remove( int row, int col );
		void SetWallColor( int c ) { WallColor = c; }
		void CalHoldPoint( int row, int col, int *x, int *y );
		size_t GetSizeFloor( void ) { return SizeFloor; }
		void CalXYBorder( int row, int col );
};

extern unsigned char far *FinalIma;
extern unsigned char far *StartIma;

#endif
